# Python机器学习

机器学习，如今最令人着迷的计算机领域(之一)。Google、Facebook、Apple、Amazon、BAT等大公司早已展开了一场关于机器学习的军备竞赛。从手机上的语音助手、垃圾邮件过滤到逛淘宝时的物品推荐，无一不用到机器学习技术。

如果你对机器学习感兴趣，甚至是想从事相关职业，那么这本书非常适合作为你的第一本机器学习资料。市面上大部分的机器学习书籍要么是告诉你如何推导模型公式要么就是如何代码实现模型算法，这对于零基础的新手来说，阅读起来相当困难。而这本书，在介绍必要的基础概念后，着重从如何调用机器学习算法解决实际问题入手，一步一步带你入门。即使你已经对很多机器学习算法的理论很熟悉了，这本书仍能从实践方面带给你一些帮助。

具体到编程语言层面，本书选择的是Python，因为它简单易懂。我们不必在枯燥的语法细节上耗费时间，一旦有了想法，你能够快速实现算法并在真实数据集上进行验证。在整个数据科学领域，Python都可以说是稳坐语言榜头号交椅。

**注意** 这是我在阅读 [Python Machine Learning](https://www.amazon.com/Python-Machine-Learning-Sebastian-Raschka/dp/1783555130) 的笔记而不是严格的原文翻译，如果发现错误，请不惜吝教~


**最后，我没有本书的翻译版权，请勿商用。转载请注明出处，谢谢:\)**

# 目录


[第二章 机器学习分类算法](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E4%BA%8C%E7%AB%A0/%E6%9C%BA%E5%99%A8%E5%AD%A6%E4%B9%A0%E5%88%86%E7%B1%BB%E7%AE%97%E6%B3%95.ipynb)

[第三章 使用scikit-learn进行分类器之旅](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E4%B8%89%E7%AB%A0/%E4%BD%BF%E7%94%A8Scikit-learn%E8%BF%9B%E8%A1%8C%E5%88%86%E7%B1%BB%E5%99%A8%E4%B9%8B%E6%97%85.ipynb)

[第四章 构建一个好的训练集---数据预处理](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E5%9B%9B%E7%AB%A0/%E6%9E%84%E5%BB%BA%E4%B8%80%E4%B8%AA%E5%A5%BD%E7%9A%84%E8%AE%AD%E7%BB%83%E9%9B%86---%E6%95%B0%E6%8D%AE%E9%A2%84%E5%A4%84%E7%90%86.ipynb)

[第五章 通过降维压缩数据](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E4%BA%94%E7%AB%A0/%E9%80%9A%E8%BF%87%E9%99%8D%E7%BB%B4%E5%8E%8B%E7%BC%A9%E6%95%B0%E6%8D%AE.ipynb)


[第六章 模型评估和调参](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E5%85%AD%E7%AB%A0/%E6%A8%A1%E5%9E%8B%E8%AF%84%E4%BC%B0%E5%92%8C%E8%B0%83%E5%8F%82.ipynb)


[第七章 集成学习](https://github.com/basicv8vc/Python-Machine-Learning-zh/blob/master/%E7%AC%AC%E4%B8%83%E7%AB%A0/%E9%9B%86%E6%88%90%E5%AD%A6%E4%B9%A0.ipynb)
